/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.iterators.lang;

import jatva.iterators.AbstractIterator;
import jatva.util.ObjectPair;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class AbstractObjectPairIterator
  extends AbstractIterator
  implements IObjectPairIterator
{
  abstract public Object  value1();
  abstract public Object  value2();
  abstract public Object  clone();
  abstract public boolean stop();
  abstract public void    shift();
  abstract public boolean equals(Object o);
  abstract public int     hashCode();

  public Object next()
  {
    Object r = new ObjectPair(value1(), value2());
    shift();
    return r;    
  }

  public String toString()
  {
    if(stop()) return jatva.iterators.Iterator.EXHAUSTED;
    return "(" + value1() + ", " + value2() + ")";
  }
}
