/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang;

import jatva.util.OperationInfo;
import jatva.util.Utils;

public class ResultTracingException
  extends RuntimeTestException
{
  public ResultTracingException ( OperationInfo op_info, Object result, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation results", error
           , new String[]{"implementation class", "implementation method", "result"}
           , new String[]{ op_info.getDeclaringClass(), op_info.getPrettySignature(), Utils.getSimpleString(result)}
         );
  }

  public ResultTracingException ( OperationInfo op_info, Object object, Object result, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation results", error
           , new String[]{"implementation object", "implementation method", "result"}
           , new String[]{Utils.getSimpleString(object), op_info.getPrettySignature(), Utils.getSimpleString(result)}
         );
  }

  public ResultTracingException ( OperationInfo op_info, Throwable exception, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation exception", error
           , new String[]{"implementation class", "implementation method", "exception"}
           , new String[]{op_info.getDeclaringClass(), op_info.getPrettySignature(), Utils.getSimpleString(exception)}
         );
  }

  public ResultTracingException (OperationInfo op_info, Object object, Throwable exception, Throwable error)
  {
    super(   "Exception occurred while trying to trace the implementation exception", error
           , new String[]{"implementation object", "implementation method", "exception"}
           , new String[]{Utils.getSimpleString(object), op_info.getPrettySignature(), Utils.getSimpleString(exception)}
         );
  }
}
