/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang;

public class TestSystemInternalError
  extends TestException
{
  public TestSystemInternalError(String info, String[] tags, String[] values)
  {
    super(info, null, true, true, true, tags, values);
  }
  
  public TestSystemInternalError(String info, Throwable error, String[] tags, String[] values)
  {
    super(info, error, true, true, true, tags, values);
  }
/*  
  public Bug(String str)
  {
    this(true, str);
  }
  
*/
  protected TestSystemInternalError(String info, Throwable error, boolean isCritical, boolean isTraced, String[] tags, String[] values)
  {
    super(info, error, isCritical, true, isTraced, tags, values);
  }
    
  protected TestSystemInternalError(String info, boolean isCritical, boolean isTraced, String[] tags, String[] values)
  {
    super(info, null, isCritical, true, isTraced, tags, values);
  }
    
  protected TestSystemInternalError(DummyClass fl, String info)
  {
    super(info, null, true, true, false, null, null);
  }

  protected TestSystemInternalError(DummyClass fl, String info, Throwable error)
  {
    super(info, error, true, true, false, null, null);
  }
  
  public static synchronized TestSystemInternalError makeUntracedBug(String str)
  {
    return new TestSystemInternalError(DummyClass.dummyObject(), str);
  }

  public static synchronized TestSystemInternalError makeUntracedBug(String str, Throwable err)
  {
    return new TestSystemInternalError(DummyClass.dummyObject(), str, err);
  }
 /* 
  public static void bugAssert(  boolean condition
                            , String p_package
                            , String p_class
                            , String p_method
                            , String info
                           )
  {
    if(!condition)
    {
      throw new TestSystemInternalError(p_package, p_class, p_method, info);
    }
  }*/
}
