/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang.services;

import jatva.util.StringToObjectMap;

/** 
 *
 * @author Victor Kuliamin
 *
 */
public class ClassData
{
  private String            name   = null;
  private StringToObjectMap fields = new StringToObjectMap();
  
  public ClassData(String name)
  {
    this.name = name;
  }
  
  public String getName()
  {
    return name;
  }
  
  public Object getField(String id)
  {
    return fields.get(id);
  }
  
  public void setField(String id, Object o)
  {
    fields.put(id, o);
  }
}
