/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.lang.synchronization;


public abstract class ActorThread extends Thread
{
  protected ActorContext actorMedium;
//  protected DeepSubject  storage;
      
  public ActorThread( ActorContext actorMedium/*, DeepSubject storage*/ )
  {
    super();
    this.actorMedium = actorMedium;
    //this.storage     = storage;
    actorMedium.registerActor( this );
  }
 
  public void run()
  {
    TestManager _lv_registrar = TestManager.getRegistrar();
    
    _lv_registrar.testFrameEnter();
    
    actorMedium.reachCommonStart();
    
    _ts_execute();
    
    actorMedium.finish();
    
    _lv_registrar.testFrameExit();
  }
  
  public abstract void _ts_execute();
      
  protected void _ts_send( ActorThread dest, Object o )
  {
    actorMedium.send( dest, o );
  }

  protected void _ts_sendAll( Object o )
  {
    actorMedium.sendAll( this, o );
  }

  protected Object _ts_receive()
  {
    return actorMedium.receive( this );
  }
}