/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.tracer;

//=============================================================================

//=============================================================================

/**
 * Value kind enumeration.
 * 
 * @author <a href="mailto:barancev@ispras.ru">Alexei Barantsev</a>
 */
public final class ValueKind {

    private String name;

    private ValueKind(String name) {
        this.name = name;
    }

    public static ValueKind GENSTATE
        = new ValueKind("state");
    public static ValueKind SCENARIO_METHOD
        = new ValueKind("scenario method");
    public static ValueKind ITERATION_VARIABLE
        = new ValueKind("iteration variable");
    public static ValueKind COLLECTION_ITERATION_VARIABLE
        // = new ValueKind("collection iteration variable");
        = new ValueKind("iteration variable");
    public static ValueKind CHOICE_ITERATION_VARIABLE
        // = new ValueKind("choice iteration variable");
        = new ValueKind("iteration variable");
    public static ValueKind COVERAGE_ITERATION_VARIABLE
        // = new ValueKind("coverage iteration variable");
        = new ValueKind("iteration variable");
    
    
    public static ValueKind ARGUMENT
        = new ValueKind("argument");
    public static ValueKind RESULT
        = new ValueKind("result");
    public static ValueKind EXCEPTION
        = new ValueKind("exception");

    public String toString() {
        return name;
    }

}

//=============================================================================
// End of ValueKind.java