/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.util;

import jatva.iterators.lang.IObjectIterator;

/**
 * The interface of sets.
 *
 * @author Victor Kuliamin
 */
public interface ISet extends Cloneable
{
  void    clear();
  int     size();
  boolean isEmpty();

  boolean add(Object o);
  boolean addAll(ISet s);
  
  boolean contains(Object o);
  boolean containsRef(Object o);
  boolean containsAll(ISet s);
  boolean isSubset(ISet s);
  
  boolean remove(Object o);
  boolean removeAll(ISet s);
  
  boolean retain(ISet s);
  
  boolean replace(Object o1, Object o2);
  boolean replace(IMap m);

  IList toList();
  Object[] toArray();
  
  ISet power();

  IObjectIterator iterator();
  
  Object  clone();
  String  toString();
  boolean equals(Object o);
  boolean equalsByRefs(Object o);
  int     hashCode();
}
