/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.util;


/**
 * @author Victor Kuliamin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class IdentityMap
  extends AbstractTreeMap 
  implements IMap
{
  public IdentityMap() {}
  
  public IdentityMap(Object key, Object val)
  {
    super(key, val);
  }
  
  public IdentityMap(IMap m)
  {
    super(m);
  }
  
  public IdentityMap(ISet s)
  {
    super(s);
  }

  public IdentityMap(ISet s, Object o)
  {
    super(s, o);
  }

  public Object clone()
  {
    return new IdentityMap(this);
  }

  protected int hashKey(Object o)
  {
    return Utils.identityHash(o);
  }
  
  protected int hashValue(Object o)
  {
    return Utils.identityHash(o);
  }
  
  protected boolean equalValues(Object o1, Object o2)
  {
    return Utils.equalObjects(o1, o2);
  }
  
  protected IList makeList()
  {
    // TODO Auto-generated method stub
    return null;
  }
  
  protected ISet makeSet()
  {
    return new IdentitySet();
  }
  
  protected IMultiSet makeMultiSet()
  {
    // TODO Auto-generated method stub
    return null;
  }

  public boolean equalsByRefs(Object o)
  {
    return equals(o);
  }
  
  public boolean containsKeyRef(Object key)
  {
    return containsKey(key);
  }

  public boolean containsValueRef(Object value)
  {
    return containsValue(value);
  }

  public boolean containsRefs(Object key, Object val)
  {
    return contains(key, val);
  }
  
  public static IMap pair(Object key, Object value)
  {
    return new IdentityMap(key, value);
  }

  public static IMap identity(ISet s)
  {
    return new IdentityMap(s);
  }

  public static IMap constant(ISet s, Object value)
  {
    return new IdentityMap(s, value);
  }

  public static IMap intersection(IMap s1, IMap s2)
  {
    IMap res = new IdentityMap(s1);
    res.retain(s2);
    
    return res;
  }
  
  public static IMap difference(IMap s1, IMap s2)
  {
    IMap res = new IdentityMap(s1);
    res.removeAll(s2);
    
    return res;
  }
  
  public static IMap symDifference(IMap s1, IMap s2)
  {
    IMap res = difference(s1, s2);
    res.putAll(difference(s2, s1));
    
    return res;
  }
  
  public static IMap composition(IMap s1, IMap s2)
  {
    IMap res = new IdentityMap(s1);
    res.compose(s2);
    
    return res;
  }
  
  public static IMap extension(IMap s1, IMap s2)
  {
    IMap res = new IdentityMap(s1);
    res.extend(s2);
    
    return res;
  }
  
}
