/*
 * Copyright 2005-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jatva.util;

import jatva.iterators.lang.IObjectIterator;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Set
  extends    AbstractHashSet
  implements ISet
{
  public Set() {}

  public Set(Object o)
  {
    super(o);
  }
  
  public Set(Set s)
  {
    super(s);
  }
  
  public Set(ISet s)
  {
    super(s);
  }

  public Object clone()
  {
    return new Set(this);
  }  
  
  public ISet power()
  {
    // TODO Auto-generated method stub
    return null;
  }

  protected int hash(Object o)
  {
    return Utils.hash(o);
  }

  protected boolean equalObjects(Object o1, Object o2)
  {
    return Utils.equalObjects(o1, o2);
  }

  protected IList makeList()
  {
    // TODO Auto-generated method stub
    return null;
  }

  public static ISet singleton(Object o)
  {
    return new Set(o);
  }

  public static ISet union(ISet s1, ISet s2)
  {
    ISet res = new Set(s1);
    res.addAll(s2);
    
    return res;
  }
  
  public static ISet intersection(ISet s1, ISet s2)
  {
    ISet res = new Set(s1);
    res.retain(s2);
    
    return res;
  }
  
  public static ISet difference(ISet s1, ISet s2)
  {
    ISet res = new Set(s1);
    res.removeAll(s2);
    
    return res;
  }
  
  public static ISet symDifference(ISet s1, ISet s2)
  {
    ISet res = difference(s1, s2);
    res.addAll(difference(s2, s1));
    
    return res;
  }
  
  public static ISet distrUnion(ISet s)
  {
    IObjectIterator i = s.iterator();
    ISet res = new Set(), t;
    
    while(!i.stop())
    {
      t = (ISet)i.value();
      res.addAll(t);
    }

    return res;    
  }
  
  public static ISet distrIntersection(ISet s)
  {
    IObjectIterator i = s.iterator();
    ISet res = null, t;
    
    while(!i.stop())
    {
      t = (ISet)i.value();
      if(res == null) res = new Set(t);
      else            res.retain(t);
    }

    return res;    
  }
}
